<!DOCTYPE html>
<html>
<head>
	<title>Customer App</title>
	 <meta name="viewport" content="width=device-width, initial-
         scale=1.0" />
</head>
<body style="margin:2%;">
	<link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-giJF6kkoqNQ00vy+HMDP7azOuL0xtbfIcaT9wjKHr8RbDVddVHyTfAAsrekwKmP1" crossorigin="anonymous">
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.0.0-beta1/dist/js/bootstrap.bundle.min.js" integrity="sha384-ygbV9kiqUc6oa4msXn9868pTtWMgiQaeYH7/t7LECLbyPA2x65Kgf80OJFdroafW" crossorigin="anonymous">
	</script>

	<h3>Customer App</h3>
	<div class="col-sm-6">
		<button class="btn btn-link" onclick="location='./customers.html'">Customers</button> | 
		<button class="btn btn-link" onclick="location='./add-customer.html'">Add</button> | 
		<button class="btn btn-link" onclick="location='./about.html'">About</button> |
		<button class="btn btn-link" onclick="location='/'" >Logout</button>
		<hr/>
	<form>
		<label class="form-label" >Name:</label>
		<input class="form-control"  id="name" placeholder="Name" name="" value=""><br/><br/>
		
		<label class="form-label">Email:</label>
		<input class="form-control"  id="email"  placeholder="Email"  name="" value=""><br/><br/>
		
		<label class="form-label">Phone:</label>
		<input class="form-control"  id="phone" placeholder="Phone"   name="" value=""><br/><br/>
		
		<label class="form-label">Address:</label>
		<input class="form-control" id="address"  placeholder="Address"  name="" value=""><br/><br/>
		

		<input class="btn btn-primary" type="button" id="addButton" name="" value="Add" onclick="addOrUpdateCustomer();"> |
		<input class="btn btn-secondary" type="button" name="" value="Cancel" onclick="resetForm();"> 
		</form><br/>
	</div>
	<script type="text/javascript">
		var customers = [ ];
		var doSearch = () =>{
			var field = document.getElementById('field').value;
			var searchText = document.getElementById('searchText').value.toLowerCase();
			console.log("searchText.."+searchText);
			console.log("field::"+field);
			console.log("searchText::"+searchText);
			let searchCustomer = customers.filter((item)=>{
				//console.log(item[field].toLowerCase() +item[field].toLowerCase().startsWith(searchText));
				return (item[field].toLowerCase().startsWith(searchText));

			}
			);
			//displayCustomers(searchCustomer);
			//implement Search // max time 20 mins
		}

		var selectedId = 0; // 0 means new record

		var sortCustomer = (sortField) =>{
			customers = customers.sort((a,b)=>{
				console.log('a:'+ JSON.stringify(a));
				console.log('b:'+ JSON.stringify(b));
				//if(a.name > b.name){
			    if(a[sortField] > b[sortField]){
			        return 1;
			    }else{
			        return -1;
			    }
			});
			//displayCustomers(customers);
			//updateStorage();
		}

		updateStorage = () =>{
			localStorage.setItem("customers", JSON.stringify(customers));
		}
		resetForm = function() {
			document.getElementById('name').value="";
			document.getElementById('email').value="";
			document.getElementById('phone').value="";
			document.getElementById('address').value="";
			document.getElementById('addButton').value="Add";
			selectedId = 0; //this indicate new Record
		}
		updateCustomer =function(id){
			//http://localhost:3000//api/login
			fetch('/api/customer/'+id, {
			  method: 'GET', // or 'PUT'
			  headers: {
			    'Content-Type': 'application/json',
			  },
			 // body: JSON.stringify({email,password}),
			})
			.then(response => response.json())
			.then(data => {
				var record = data;
			if(record.id){
				selectedId = record.id; //selected record Id
				document.getElementById('name').value=record.name;
				document.getElementById('email').value=record.email;
				document.getElementById('phone').value=record.phone;
				document.getElementById('address').value=record.address;
				document.getElementById('addButton').value="Update";
			}
			})
			.catch((error) => {
			  console.error('Error:', error);
			});
		}
		addOrUpdateCustomer = function(){
			var name = document.getElementById('name').value;
			var email = document.getElementById('email').value;
			var phone = document.getElementById('phone').value;
			var address = document.getElementById('address').value;

			if(selectedId == 0){ //means new record to add
				var len = customers.length;
				if(len > 0){
					let lastId = customers[len - 1].id
					var id =lastId +1
				}else{
					var id = 1;
				}

			  fetch('/api/customer', {
			  method: 'POST', // or 'PUT'
			  headers: {
			    'Content-Type': 'application/json',
			  },
			  body: JSON.stringify({name,email,address,phone}),
			})
			.then(response => response.json())
			.then(data => {
				var record = data;
				location = 'customers.html';
			})
			.catch((error) => {
			  console.error('Error:', error);
			});

				//customers.push({id,name,email,phone,address});
			}else{ // record to update
				var id = selectedId; //selected record Id

			  fetch('/api/customer', {
			  method: 'PUT', // or 'PUT'
			  headers: {
			    'Content-Type': 'application/json',
			  },
			  body: JSON.stringify({id,name,email,address,phone}),
			})
			.then(response => response.json())
			.then(data => {
				var record = data;
				location = 'customers.html';
			})
			.catch((error) => {
			  console.error('Error:', error);
			});
			}	
			//updateStorage();
			//displayCustomers(customers);
			//resetForm();
			//location = 'customers.html';
		}
	
		deleteCustomer =function(id){
			customers = customers.filter((item) => (item.id != id));
			updateStorage();
			displayCustomers(displayCustomers);
		}
		displayCustomers = function(customers){
			//JSON.stringify(s);
			console.log(customers.length);
			const list = document.getElementById("result"); //result is the list
			list.innerHTML = "";
			for (var i=0; i < customers.length; i++  ) {
				let id = customers[i].id;
				const newRecord = document.createElement("tr");
				
				const newId = document.createElement("td");
				newId.innerHTML = customers[i].id;

				const newName = document.createElement("td");
				newName.innerHTML = customers[i].name;

				const newEmail = document.createElement("td");
				newEmail.innerHTML = customers[i].email;

				const newPhone = document.createElement("td");
				newPhone.innerHTML = customers[i].phone;

				const newAddress = document.createElement("td");
				newAddress.innerHTML = customers[i].address;

				newRecord.appendChild(newId);
				newRecord.appendChild(newName);
				newRecord.appendChild(newEmail);
				newRecord.appendChild(newPhone);
				newRecord.appendChild(newAddress);

				const newDeleteButton = document.createElement("td");
			  	
			  	const newButton = document.createElement("BUTTON");
			  	newButton.innerHTML = 'delete'; 
			  	newButton.setAttribute("class", "btn btn-danger");
			  	newButton.onclick = function(e){
			  		//avoid default behaviour to post form data
			  		e.preventDefault();
			  		console.log('delete :'+id);
			  		deleteCustomer(id);
			  		
				}
				newDeleteButton.appendChild(newButton);

				const newEditButton = document.createElement("td");
			  	const newEButton = document.createElement("BUTTON");
			  	newEButton.innerHTML = 'edit'; 
			  	newEButton.setAttribute("class", "btn btn-info"); 
			  	newEButton.onclick = function(e){
			  		//avoid default behaviour to post form data
			  		e.preventDefault();
			  		console.log('edit :'+id);
			  		updateCustomer(id);
			  		
				}
				newEditButton.appendChild(newEButton);
				newRecord.appendChild(newEditButton);
				newRecord.appendChild(newDeleteButton);
			  	
			  	list.appendChild(newRecord);
			}
		}
		const urlParams = new URLSearchParams(location.search);

		for (const [key, id] of urlParams) {
			//id=1606037560306
		    console.log(`${key}:${id}`);
		    console.log(key+":"+id);
		    if(key == 'id'){
		    	console.log('id value:'+id);
		    	updateCustomer(id);
		     break;	
		    }
		}
		//displayCustomers(customers);
	</script>
</body>
</html>
